fv(X,[]) :- integer(X),!.
fv(X,[X]) :- atomic(X).
fv(A,R) :- A =.. [_,T1,T2] , fv(T1,FT1), fv(T2,FT2),
		append(FT1,FT2,R).
fv(A,FT1) :- A =.. [_,T1] , fv(T1,FT1).

ok(X) :- number(X),!.
ok(A):- A =.. [_,T1,T2] , ok(T1),ok(T2).
ok(A) :- A =.. [_,T1] , ok(T1).


ev(X,Y) :- ok(X),!,Y is X.
ev(A*1,Y) :- ev(A,Y),!.
ev(A+0,Y) :- ev(A,Y),!.
ev(A-0,Y) :- ev(A,Y),!.
ev(A^1,AE) :- ev(A,AE),!.
ev(A^0,1) :- !.
ev(A*B,AE*BE) :- ev(A,AE),ev(B,BE),!.
ev(A+B,AE+BE) :- ev(A,AE),ev(B,BE),!.
ev(A-B,AE-BE) :- ev(A,AE),ev(B,BE),!.
ev(A^B,AE^BE) :- ev(A,AE),ev(B,BE),!.
ev(X,X).

d(A, A, 1) :- !.
d(A, _, 0) :- atomic(A).
d(-A, B, -C) :- d(A, B, C).
d(A+B, C, R) :- d(A, C, D), d(B, C, E), ev(D+E,R).
d(A-B, C, R) :- d(A, C, D), d(B, C, E), ev(D-E,R).
d(A*B, C, R) :- atomic(A), d(B, C, D),ev(D,Dd), ev(A*D,R),!.
d(A*B, C, R) :- d(A, C, E), d(B, C, D), ev(D,Dd), ev(E,Ee),ev(Dd*A+Ee*B,R).
d(A/B, C, Dd) :- d(A*B^(-1), C, D), ev(D,Dd).
d(A^B, C, R) :- atomic(B), d(A, C, D), ev(B*A^(B-1)*D,R).
d(log(A), B, C*A^ -1) :- d(A, B, C).

