#include<iostream>
using namespace std;

class Frame {
public:
  	enum Linestyle {Solid,Dashed, Dotted};
private:
	int x,y;
	int w,h;
	Linestyle ls;
	double lw;
public:
	Frame(int a, int b, int c, int d) {
		x=a; y=b; w=c; h=d; ls=Solid; lw=1;
		cout << '(' << a << ',' << b << ','<< c << ','<< 
			d << ")\n";
	}
	Frame(int a, int b, int c, int d, Linestyle e, double f) {
		x=a; y=b; w=c; h=d;
		ls=e; lw=f;
		cout << '(' << a << ',' << b << ','<< c << ','<< 
			d << ',' << e << ',' << f << ")\n";
	}
	Frame() { x=y=w=h=0; ls=Solid; lw=1; cout << "()\n";}
	~Frame() { cout << "destructed "; out();}
	void out() { cout << '(' << x << ',' << y << ';'<< w << ','<< 
			h << ':' << ls << ',' << lw << ")\n";
		   }
	void draw() { cout << "drawn "; out();}
};

class Text {
	char *p;
public:
	Text(const char *s) {
		int i;
		for (i=0; s[i];i++) ;
		p = new char[i+1];
		for (i=0; s[i];i++) p[i]=s[i]; p[i]=0;
		cout << "cons:" << p << '\n';
	}
	Text() {
		int i;
		char def[]="null";
		p=new char[5];
		for (i=0;i<5;i++) p[i]=def[i];
		cout << "cons:" << p << '\n';
	}
	~Text() {
		cout << "destructed " << p << '\n';delete [] p; 
	}
	void draw() { cout << "drawn " << p << "\n"; }
};


class TextBox {
	Text text;
	Frame frm;
public:
	TextBox() { cout << "textbox construct\n";}
	TextBox(int a, int b, int c, int d, const char *s)
			:frm(a,b,c,d),text(s) {
		   cout << "textbox construct\n";}
	TextBox(int a, int b, int c, int d, Frame::Linestyle e,
				double f, const char *s)
			:frm(a,b,c,d,e,f),text(s) {
		   cout << "textbox construct\n";}
	~TextBox() { cout << "textbox destruct\n";}
	void draw() {
		text.draw();
		frm.draw();
	}
};

int main() {
	TextBox a;
	TextBox b(3,2,10,20,"ali");
	TextBox c(5,5,10,20,Frame::Dotted,0.5,"veli");

	a.draw();
	cout << "--------------\n";
	b.draw();
	cout << "--------------\n";
	c.draw();

	return 0;
}
